#include "IO_dict.h"

AFun IO_afun0;
AFun IO_afun2;
AFun IO_afun3;
AFun IO_afun1;

ATerm IO_patternStrConStrCon = NULL;
ATerm IO_patternStrCharStrChar = NULL;
ATerm IO_patternSegmentListMany = NULL;
ATerm IO_patternSegmentListSingle = NULL;
ATerm IO_patternSegmentListEmpty = NULL;
ATerm IO_patternSegmentSegment = NULL;
ATerm IO_patternPathRelative = NULL;
ATerm IO_patternPathAbsolute = NULL;
ATerm IO_patternFileFile = NULL;

/*
 * IO_afun0 = file(x,x,x)
 * IO_afun2 = relative(x)
 * IO_afun3 = segment(x)
 * IO_afun1 = absolute(x)
 *
 * IO_patternStrConStrCon = <str>
 * IO_patternStrCharStrChar = <str>
 * IO_patternSegmentListMany = [<term>,<list>]
 * IO_patternSegmentListSingle = [<term>]
 * IO_patternSegmentListEmpty = []
 * IO_patternSegmentSegment = segment(<str>)
 * IO_patternPathRelative = relative(<term>)
 * IO_patternPathAbsolute = absolute(<term>)
 * IO_patternFileFile = file(<term>,<str>,<str>)
 *
 */

static ATerm _IO_dict = NULL;

#define _IO_dict_LEN 165

static char _IO_dict_baf[_IO_dict_LEN] = {
0x00,0x8B,0xAF,0x83,0x00,0x0B,0x22,0x03,0x3C,0x5F,0x3E,0x01,0x00,0x03,0x03,0x04,
0x05,0x03,0x05,0x5B,0x5F,0x2C,0x5F,0x5D,0x02,0x00,0x12,0x07,0x01,0x02,0x00,0x07,
0x08,0x09,0x0A,0x02,0x01,0x02,0x02,0x5B,0x5D,0x00,0x00,0x01,0x03,0x73,0x74,0x72,
0x00,0x00,0x01,0x04,0x6C,0x69,0x73,0x74,0x00,0x00,0x01,0x04,0x74,0x65,0x72,0x6D,
0x00,0x00,0x01,0x01,0x78,0x00,0x00,0x01,0x04,0x66,0x69,0x6C,0x65,0x03,0x00,0x02,
0x02,0x00,0x06,0x02,0x00,0x06,0x02,0x00,0x06,0x08,0x72,0x65,0x6C,0x61,0x74,0x69,
0x76,0x65,0x01,0x00,0x02,0x02,0x00,0x06,0x07,0x73,0x65,0x67,0x6D,0x65,0x6E,0x74,
0x01,0x00,0x02,0x02,0x00,0x06,0x08,0x61,0x62,0x73,0x6F,0x6C,0x75,0x74,0x65,0x01,
0x00,0x02,0x02,0x00,0x06,0x01,0x18,0xC5,0x42,0x09,0x10,0xA4,0x01,0x94,0x04,0x79,
0x08,0xE4,0x16,0x14,0x54,0x11,0x24,0x18,0x31,0x51,0xA8,0x2A,0xC0,0x48,0xC4,0x09,
0xC4,0x73,0x44,0x01,0x40
};

void init_IO_dict()
{
  ATermList afuns, terms;

  _IO_dict = ATreadFromBinaryString(_IO_dict_baf, _IO_dict_LEN);

  ATprotect(&_IO_dict);

  afuns = (ATermList)ATelementAt((ATermList)_IO_dict, 0);

  IO_afun0 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  IO_afun2 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  IO_afun3 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  IO_afun1 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);

  terms = (ATermList)ATelementAt((ATermList)_IO_dict, 1);

  IO_patternStrConStrCon = ATgetFirst(terms);
  terms = ATgetNext(terms);
  IO_patternStrCharStrChar = ATgetFirst(terms);
  terms = ATgetNext(terms);
  IO_patternSegmentListMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  IO_patternSegmentListSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  IO_patternSegmentListEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
  IO_patternSegmentSegment = ATgetFirst(terms);
  terms = ATgetNext(terms);
  IO_patternPathRelative = ATgetFirst(terms);
  terms = ATgetNext(terms);
  IO_patternPathAbsolute = ATgetFirst(terms);
  terms = ATgetNext(terms);
  IO_patternFileFile = ATgetFirst(terms);
  terms = ATgetNext(terms);
}
